## visad.cluster
Class RemoteClientTupleImpl

    java.lang.Object
      java.rmi.server.RemoteObject
          java.rmi.server.RemoteServer
              java.rmi.server.UnicastRemoteObject
                  visad.RemoteThingImpl
                      visad.RemoteDataImpl
                          visad.cluster.RemoteClusterDataImpl
                              visad.cluster.RemoteClientDataImpl
                                  visad.cluster.RemoteClientTupleImpl

All Implemented Interfaces:
  Data, Remote, RemoteClientData, RemoteClientTuple, RemoteClusterData, RemoteData, RemoteThing, RemoteTupleIface, Serializable, Thing, TupleIface

public class RemoteClientTupleImpl
extends RemoteClientDataImpl
implements RemoteClientTuple

RemoteClientTupleImpl is the class for cluster client VisAD Tuple data objects.

See Also:
  Serialized Form

Field Summary

Fields inherited from class visad.RemoteDataImpl
``

Fields inherited from class visad.RemoteThingImpl
``

Fields inherited from class java.rmi.server.RemoteObject
`ref`

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Constructor Summary
`RemoteClientTupleImpl(Data[] datums)` must call setupClusterData after constructor to finish the "construction"

Method Summary
`Data` `adjustSamplingError(Data error, int error_mode)` return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode
`double[][]` `computeRanges(RealType[] reals)` compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D
`DataShadow` `computeRanges(ShadowType type, DataShadow shadow)` Recursive version of computeRanges(), called down through Data object tree.
`DataShadow` `computeRanges(ShadowType type, int n)` Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector.
`Data` `getComponent(int i)` return component for i between 0 and getDimension() - 1
`int` `getDimension()` return number of components
`Real[]` `getRealComponents()`
`MathType` `getType()`
`boolean` `isMissing()`
`String` `longString()`
`String` `longString(String pre)`

Methods inherited from class visad.cluster.RemoteClientDataImpl
`binary, binary, unary, unary`

Methods inherited from class visad.cluster.RemoteClusterDataImpl
`addReference, clusterDataEquals, getClusterData, getPartitionSet, getTable, local, main, notifyReferences, removeReference, setParent, setupClusterData`

Methods inherited from class visad.RemoteDataImpl

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, ceil, ceil, changeMathType, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, log, log, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees`

Methods inherited from class visad.RemoteThingImpl
`getTick, incTick`

Methods inherited from class java.rmi.server.UnicastRemoteObject
`clone, exportObject, exportObject, exportObject, unexportObject`

Methods inherited from class java.rmi.server.RemoteServer
`getClientHost, getLog, setLog`

Methods inherited from class java.rmi.server.RemoteObject
`equals, getRef, hashCode, toString, toStub`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface visad.cluster.RemoteClusterData
`clusterDataEquals, getClusterData, setupClusterData`

Methods inherited from interface visad.Data

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, local, log, log, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Methods inherited from interface visad.RemoteThing
`getTick, incTick`

Methods inherited from interface visad.TupleIface
`binary, unary`

Constructor Detail

### RemoteClientTupleImpl

    public RemoteClientTupleImpl(Data[] datums)
                          throws VisADException,
                                 RemoteException

  must call setupClusterData after constructor to finish the "construction"

Method Detail

### getType

    public MathType getType()
                     throws VisADException,
                            RemoteException

  Specified by:
    `getType` in interface `Data`
  Overrides:
    `getType` in class `RemoteDataImpl`
  Returns:
    MathType of this Data
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### getRealComponents

    public Real[] getRealComponents()
                             throws VisADException,
                                    RemoteException

  Specified by:
    `getRealComponents` in interface `TupleIface`
  Throws:
    `VisADException`
    `RemoteException`

### getDimension

    public int getDimension()
                     throws RemoteException

  Description copied from interface: `TupleIface`
  return number of components

  Specified by:
    `getDimension` in interface `TupleIface`
  Throws:
    `RemoteException`

### getComponent

    public Data getComponent(int i)
                      throws VisADException,
                             RemoteException

  Description copied from interface: `TupleIface`
  return component for i between 0 and getDimension() - 1

  Specified by:
    `getComponent` in interface `TupleIface`
  Throws:
    `VisADException`
    `RemoteException`

### isMissing

    public boolean isMissing()
                      throws RemoteException

  Specified by:
    `isMissing` in interface `Data`
  Overrides:
    `isMissing` in class `RemoteDataImpl`
  Returns:
    flag indicating whether this Data has a missing value
  Throws:
    `RemoteException` - an RMI error occurred

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    DataShadow shadow)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  Recursive version of computeRanges(), called down through Data object tree.

  Specified by:
    `computeRanges` in interface `Data`
  Overrides:
    `computeRanges` in class `RemoteDataImpl`
  Parameters:
    `type` - ShadowType generated for MathType of this
    `shadow` - DataShadow instance whose contained double[][] array and animation sampling Set are modified according to RealType values in this, and used as return value
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    int n)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector. Called from DataRenderer with n = DisplayImpl.getScalarCount().

  Specified by:
    `computeRanges` in interface `Data`
  Overrides:
    `computeRanges` in class `RemoteDataImpl`
  Parameters:
    `type` - ShadowType generated for MathType of this
    `n` - number of RealTypes in DisplayImpl.RealTypeVector
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public double[][] computeRanges(RealType[] reals)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D

  Specified by:
    `computeRanges` in interface `Data`
  Overrides:
    `computeRanges` in class `RemoteDataImpl`
  Returns:
    double[reals.length][2] giving the low and high value in this for each RealType in reals
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### adjustSamplingError

    public Data adjustSamplingError(Data error,
                                    int error_mode)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode

  Specified by:
    `adjustSamplingError` in interface `Data`
  Overrides:
    `adjustSamplingError` in class `RemoteDataImpl`
  Parameters:
    `error` -
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    clone of this, except with ErrorEstimates set according to values in error
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### longString

    public String longString()
                      throws VisADException,
                             RemoteException

  Specified by:
    `longString` in interface `Data`
  Overrides:
    `longString` in class `RemoteDataImpl`
  Returns:
    a longer String than returned by toString()
  Throws:
    `VisADException`
    `RemoteException`

### longString

    public String longString(String pre)
                      throws VisADException,
                             RemoteException

  Specified by:
    `longString` in interface `Data`
  Overrides:
    `longString` in class `RemoteDataImpl`
  Parameters:
    `pre` - String added to start of each line
  Returns:
    a longer String than returned by toString(), indented by pre (a string of blanks)
  Throws:
    `VisADException`
    `RemoteException`